Codeforces Beta Round #3 B. Lorry 暴力 二分

B. Lorry

题目连接:

http://www.codeforces.com/contest/3/problem/B

Description

A group of tourists is going to kayak and catamaran tour. A rented lorry has arrived to the boat depot to take kayaks and catamarans to the point of departure. It’s known that all kayaks are of the same size (and each of them occupies the space of 1 cubic metre), and all catamarans are of the same size, but two times bigger than kayaks (and occupy the space of 2 cubic metres).

Each waterborne vehicle has a particular carrying capacity, and it should be noted that waterborne vehicles that look the same can have different carrying capacities. Knowing the truck body volume and the list of waterborne vehicles in the boat depot (for each one its type and carrying capacity are known), find out such set of vehicles that can be taken in the lorry, and that has the maximum total carrying capacity. The truck body volume of the lorry can be used effectively, that is to say you can always put into the lorry a waterborne vehicle that occupies the space not exceeding the free space left in the truck body.

Input

The first line contains a pair of integer numbers n and v (1 ≤ n ≤ 105; 1 ≤ v ≤ 109), where n is the number of waterborne vehicles in the boat depot, and v is the truck body volume of the lorry in cubic metres. The following n lines contain the information about the waterborne vehicles, that is a pair of numbers ti, pi (1 ≤ ti ≤ 2; 1 ≤ pi ≤ 104), where ti is the vehicle type (1 – a kayak, 2 – a catamaran), and pi is its carrying capacity. The waterborne vehicles are enumerated in order of their appearance in the input file.

Output

In the first line print the maximum possible carrying capacity of the set. In the second line print a string consisting of the numbers of the vehicles that make the optimal set. If the answer is not unique, print any of them.

Sample Input

3 2
1 2
2 7
1 3

Sample Output

7
2

Hint

题意

给你n个物品,然后给你一个体积为v的背包。

每个物品的体积只可能是1,或者2.

每个物品都有价值。

问你这个背包最多装多少价值的物品走。

题解:

总共就两种物品嘛,随便搞搞。

暴力枚举一种物品,然后二分另外一种物品就好了。

当然你想two pointer也是兹瓷的。

代码

#include<bits/stdc++.h>
using namespace std;
const int maxn = 1e5+7;
pair<int,int> p1[maxn],p2[maxn];
int sum1[maxn],sum2[maxn];
int n1,n2;
bool cmp(pair<int,int> A,pair<int,int> B)
{
    return A.first>B.first;
}
int main()
{
    int n,v;
    scanf("%d%d",&n,&v);
    for(int i=1;i<=n;i++)
    {
        int x,y;scanf("%d%d",&x,&y);
        if(x==1)p1[++n1]=make_pair(y,i);
        else p2[++n2]=make_pair(y,i);
    }
    sort(p1+1,p1+1+n1,cmp);
    sort(p2+1,p2+1+n2,cmp);
    for(int i=1;i<=n1;i++)
        sum1[i]=sum1[i-1]+p1[i].first;
    for(int i=1;i<=n2;i++)
        sum2[i]=sum2[i-1]+p2[i].first;
    int Ans=0,x=0,y=0;
    for(int i=0;i<=n1;i++)
    {
        if(i>v)break;
        int l=0,r=n2,ans=0;
        while(l<=r)
        {
            int mid = (l+r)/2;
            if(2*mid<=v-i)ans=mid,l=mid+1;
            else r=mid-1;
        }
        int tmp=sum1[i]+sum2[ans];
        if(tmp>Ans)
        {
            Ans=tmp;
            x=i,y=ans;
        }
    }
    printf("%d\n",Ans);
    for(int i=1;i<=x;i++)
        printf("%d ",p1[i].second);
    for(int i=1;i<=y;i++)
        printf("%d ",p2[i].second);
}
    原文作者:qscqesze
    原文地址: https://www.cnblogs.com/qscqesze/p/5266593.html
    本文转自网络文章,转载此文章仅为分享知识,如有侵权,请联系博主进行删除。
点赞